using System.Collections.Generic;
using Microsoft.AspNetCore.Mvc;
using System.Threading.Tasks;
using System.Text.Json;
using System.Text.Json.Serialization;

namespace OSI.API.Controllers
{
    public abstract class EndpointBase<A> : ControllerBase
    {
        [HttpGet]
        public abstract IActionResult Get();

        // GET: api/Clients/5
        [HttpGet("{id}")]
        public abstract IActionResult Get(int id);

        // POST: api/Clients
        [HttpPost]
        public abstract IActionResult Create([FromBody] A input);

        // PUT: api/Clients/5
        [HttpPut("{id}")]
        public abstract IActionResult Update([FromBody] A input);

        // DELETE: api/Clients/5
        [HttpDelete("{id}")]
        public abstract IActionResult Delete(int id);

        protected T FromJSON<T>(string input)
        {
            JsonSerializerOptions options = new()
            {
                Converters = {
                   new JsonStringEnumConverter()
               }
            };

            return JsonSerializer.Deserialize<T>(input, options);
        }

        protected string ToJSON<T>(T input)
        {
            JsonSerializerOptions options = new()
            {
                WriteIndented = true,
                Converters = {
                    new JsonStringEnumConverter()
                }
            };

            return JsonSerializer.Serialize<T>(input, options);
        }
    }
}